"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.applyFunctions = applyFunctions;
exports.checkTabId = checkTabId;
exports.getTabId = getTabId;
var _find2 = _interopRequireDefault(require("lodash/find"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var TAB_ID = 'id';
function getTabId(tabValues) {
  return tabValues[TAB_ID];
}
function checkTabId(newTabData, tabs) {
  var id = getTabId(newTabData);
  if (id === undefined) {
    throw new Error('id field must be defined');
  }
  var tab = (0, _find2.default)(tabs, function (tab) {
    return id === getTabId(tab);
  });
  if (tab) {
    throw new Error('id of a tab must be unique');
  }
}
function applyFunctions() {
  for (var _len = arguments.length, fns = new Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }
  return function () {
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }
    return fns.forEach(function (fn) {
      return fn === null || fn === void 0 ? void 0 : fn.apply(void 0, args);
    });
  };
}
// #sourceMappingURL=utils.js.map
// #sourceMappingURL=utils.js.map