"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _react = _interopRequireDefault(require("react"));
var _cn = require("../../helpers/cn");
var _findIndex2 = _interopRequireDefault(require("lodash/findIndex"));
var _TabField = _interopRequireDefault(require("./TabField"));
var _uikit = require("@gravity-ui/uikit");
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var _excluded = ["className", "activeTab", "size", "sortable", "tabItems", "onOrderChanged"];
var block = (0, _cn.dfCN)('tab-field-vertical');
var ITEM_HEIGHT = {
  s: 28,
  m: 36,
  l: 48
};
var TabFieldVertical = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(TabFieldVertical, _React$Component);
  var _super = (0, _createSuper2.default)(TabFieldVertical);
  function TabFieldVertical() {
    var _this;
    (0, _classCallCheck2.default)(this, TabFieldVertical);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _this.onItemClick = function (item) {
      var setActiveTab = _this.props.setActiveTab;
      setActiveTab(item.id);
    };
    _this.renderItem = function (item) {
      var _this$props = _this.props,
        onRemoveTab = _this$props.onRemoveTab,
        onCreateTab = _this$props.onCreateTab,
        wrapTo = _this$props.wrapTo;
      var node = _TabField.default.wrapTabItem(onRemoveTab, onCreateTab, item, item.title, {
        vertical: true
      });
      return wrapTo ? wrapTo(node, item) : node;
    };
    return _this;
  }
  (0, _createClass2.default)(TabFieldVertical, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        className = _this$props2.className,
        activeTab = _this$props2.activeTab,
        size = _this$props2.size,
        sortable = _this$props2.sortable,
        tabItems = _this$props2.tabItems,
        onOrderChanged = _this$props2.onOrderChanged,
        rest = (0, _objectWithoutProperties2.default)(_this$props2, _excluded);
      var selected = (0, _findIndex2.default)(tabItems, function (_ref) {
        var id = _ref.id;
        return id === activeTab;
      });
      return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: block({
          size: size
        }, className),
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_uikit.List, (0, _objectSpread2.default)({
          className: block('list'),
          itemHeight: ITEM_HEIGHT[size || TabFieldVertical.defaultProps.size],
          size: size,
          items: tabItems,
          renderItem: this.renderItem,
          onItemClick: this.onItemClick,
          selectedItemIndex: selected,
          filterable: false,
          onSortEnd: onOrderChanged,
          sortable: sortable
        }, rest))
      });
    }
  }]);
  return TabFieldVertical;
}(_react.default.Component);
TabFieldVertical.defaultProps = {
  size: 's'
};
TabFieldVertical.isTabControl = true;
TabFieldVertical.isTabControlVertical = true;
TabFieldVertical.getDefaultValue = _TabField.default.getDefaultValue;
TabFieldVertical.isEmpty = _TabField.default.isEmpty;
var _default = TabFieldVertical; // #sourceMappingURL=TabFieldVertical.js.map
exports.default = _default;
// #sourceMappingURL=TabFieldVertical.js.map