var subscribers = [];
var config = readOnly({
  lang: 'en'
});
function readOnly(newConfig) {
  return new Proxy(newConfig, {
    set: function set() {
      throw new Error('Do not edit the config directly');
    }
  });
}
export var configure = function configure(newConfig) {
  config = readOnly(Object.assign({}, config, newConfig));
  subscribers.forEach(function (sub) {
    sub(config);
  });
};
export var subscribeConfigure = function subscribeConfigure(sub) {
  subscribers.push(sub);
  sub(config);
  return function () {
    subscribers = subscribers.filter(function (item) {
      return item !== sub;
    });
  };
};
export var getConfig = function getConfig() {
  return config;
};
// #sourceMappingURL=configure.js.map