import React from 'react';
import './EditableList.scss';
export interface EditableListProps<T = any> {
    className?: string;
    itemClassName?: string;
    value: Array<EditableListItemType<T>>;
    maxVisibleCount?: number;
    itemRenderer?: (item: EditableListItemType<T>) => React.ReactNode;
    frozen?: boolean;
    onChange: (value: EditableListProps<T>['value']) => void;
}
export interface EditableListItemType<T> {
    title: string;
    removed?: boolean;
    frozen?: boolean;
    data?: T;
}
interface State {
    showAll: boolean;
}
declare class EditableList<T = any> extends React.Component<EditableListProps<T>, State> {
    static defaultProps: {
        value: never[];
    };
    static getDefaultValue(): never[];
    static isEmpty(): boolean;
    state: State;
    renderItem: (item: EditableListItemType<T>, index: number) => React.JSX.Element;
    toggleRemove: (item: EditableListItemType<T>, index: number) => void;
    renderShowAll(): React.JSX.Element;
    onShowAll: () => void;
    render(): React.JSX.Element;
}
export default EditableList;
