import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React from 'react';
import { useStableEventHandler } from '../../helpers/useStableEventHendler';
import { applyFunctions } from '../Dialog/utils';
import { jsx as _jsx } from "react/jsx-runtime";
function noop() {}
export function FocusBlurContainer(_ref) {
  var children = _ref.children,
    className = _ref.className,
    onFocus = _ref.onFocus,
    _ref$onBlur = _ref.onBlur,
    onBlur = _ref$onBlur === void 0 ? noop : _ref$onBlur;
  var _React$useState = React.useState(false),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    focused = _React$useState2[0],
    setFocused = _React$useState2[1];
  var handleBlur = useStableEventHandler(applyFunctions(onBlur, function () {
    setFocused(false);
  }));
  var handleFocus = useOnFocusOutside(handleBlur, focused);
  var handleClick = useOnClickOutside(handleBlur, focused);
  return /*#__PURE__*/_jsx("div", {
    className: className,
    onFocus: applyFunctions(handleFocus, onFocus, function () {
      setFocused(true);
    }),
    onClick: handleClick,
    children: children
  });
}
function useOnFocusOutside(onFocusOutside) {
  var enable = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var capturedRef = React.useRef(false);
  React.useEffect(function () {
    if (enable) {
      var handleFocus = function handleFocus() {
        capturedRef.current = false;
        window.setTimeout(function () {
          if (!capturedRef.current) {
            onFocusOutside();
          }
        }, 0);
      };
      window.addEventListener('focus', handleFocus, {
        capture: true
      });
      return function () {
        window.removeEventListener('focus', handleFocus, {
          capture: true
        });
      };
    }
    return undefined;
  }, [enable, onFocusOutside]);
  return React.useCallback(function () {
    capturedRef.current = true;
  }, []);
}
function useOnClickOutside(onClickOutside) {
  var enable = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var capturedRef = React.useRef(false);
  React.useEffect(function () {
    if (enable) {
      var handleClick = function handleClick() {
        capturedRef.current = false;
        window.setTimeout(function () {
          if (!capturedRef.current) {
            onClickOutside();
          }
        }, 0);
      };
      window.addEventListener('click', handleClick, {
        capture: true
      });
      return function () {
        window.removeEventListener('click', handleClick, {
          capture: true
        });
      };
    }
    return undefined;
  }, [enable, onClickOutside]);
  return React.useCallback(function () {
    capturedRef.current = true;
  }, []);
}
// #sourceMappingURL=FocusBlurContainer.js.map