import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import React, { Component } from 'react';
import _map from 'lodash/map';
import { Button, Label } from '@gravity-ui/uikit';
import { dfCN } from '../../../helpers/cn';
import withCollapsible from '../../../hoc/withCollapsible';
import './LabelsGroup.css';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var block = dfCN('labels-group');
var LabelsGroup = /*#__PURE__*/function (_Component) {
  _inherits(LabelsGroup, _Component);
  var _super = _createSuper(LabelsGroup);
  function LabelsGroup() {
    var _this;
    _classCallCheck(this, LabelsGroup);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _this.handleLabelClick = function (label) {
      var onClick = _this.props.onClick;
      if (typeof onClick === 'function') {
        onClick(label);
      }
    };
    _this.handleRemoveClick = function (evt, label) {
      var onRemove = _this.props.onRemove;
      evt.stopPropagation();
      if (typeof onRemove === 'function') {
        onRemove(label);
      }
    };
    return _this;
  }
  _createClass(LabelsGroup, [{
    key: "renderLabel",
    value: function renderLabel(label) {
      var _this2 = this;
      var _this$props = this.props,
        onRemove = _this$props.onRemove,
        disabled = _this$props.disabled;
      var name = label.name,
        isDefault = label.isDefault;
      var onLabelClick = function onLabelClick() {
        return _this2.handleLabelClick(label);
      };
      var onRemoveClick = function onRemoveClick(evt) {
        return _this2.handleRemoveClick(evt, label);
      };
      return /*#__PURE__*/_jsx(Label, {
        className: block('label'),
        type: onRemove && !isDefault ? 'close' : 'default',
        onClick: onLabelClick,
        onCloseClick: onRemoveClick,
        size: "s",
        disabled: disabled,
        children: name
      }, name);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props2 = this.props,
        items = _this$props2.items,
        renderToggler = _this$props2.renderToggler,
        onRemoveAll = _this$props2.onRemoveAll,
        disabled = _this$props2.disabled;
      return /*#__PURE__*/_jsxs("div", {
        className: block(),
        children: [_map(items, function (label) {
          return _this3.renderLabel(label);
        }), renderToggler === null || renderToggler === void 0 ? void 0 : renderToggler(), onRemoveAll && items.length > 0 && /*#__PURE__*/_jsx(Button, {
          size: "s",
          view: "flat-secondary",
          onClick: onRemoveAll,
          disabled: disabled,
          children: "Clear all"
        })]
      });
    }
  }]);
  return LabelsGroup;
}(Component);
export default withCollapsible(LabelsGroup);
// #sourceMappingURL=LabelsGroup.js.map