import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
var _excluded = ["className", "activeTab", "size", "sortable", "tabItems", "onOrderChanged"];
import React from 'react';
import { dfCN } from '../../helpers/cn';
import _findIndex from 'lodash/findIndex';
import TabField from './TabField';
import { List } from '@gravity-ui/uikit';
import './TabFieldVertical.css';
import { jsx as _jsx } from "react/jsx-runtime";
var block = dfCN('tab-field-vertical');
var ITEM_HEIGHT = {
  s: 28,
  m: 36,
  l: 48
};
var TabFieldVertical = /*#__PURE__*/function (_React$Component) {
  _inherits(TabFieldVertical, _React$Component);
  var _super = _createSuper(TabFieldVertical);
  function TabFieldVertical() {
    var _this;
    _classCallCheck(this, TabFieldVertical);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _this.onItemClick = function (item) {
      var setActiveTab = _this.props.setActiveTab;
      setActiveTab(item.id);
    };
    _this.renderItem = function (item) {
      var _this$props = _this.props,
        onRemoveTab = _this$props.onRemoveTab,
        onCreateTab = _this$props.onCreateTab,
        wrapTo = _this$props.wrapTo;
      var node = TabField.wrapTabItem(onRemoveTab, onCreateTab, item, item.title, {
        vertical: true
      });
      return wrapTo ? wrapTo(node, item) : node;
    };
    return _this;
  }
  _createClass(TabFieldVertical, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        className = _this$props2.className,
        activeTab = _this$props2.activeTab,
        size = _this$props2.size,
        sortable = _this$props2.sortable,
        tabItems = _this$props2.tabItems,
        onOrderChanged = _this$props2.onOrderChanged,
        rest = _objectWithoutProperties(_this$props2, _excluded);
      var selected = _findIndex(tabItems, function (_ref) {
        var id = _ref.id;
        return id === activeTab;
      });
      return /*#__PURE__*/_jsx("div", {
        className: block({
          size: size
        }, className),
        children: /*#__PURE__*/_jsx(List, _objectSpread({
          className: block('list'),
          itemHeight: ITEM_HEIGHT[size || TabFieldVertical.defaultProps.size],
          size: size,
          items: tabItems,
          renderItem: this.renderItem,
          onItemClick: this.onItemClick,
          selectedItemIndex: selected,
          filterable: false,
          onSortEnd: onOrderChanged,
          sortable: sortable
        }, rest))
      });
    }
  }]);
  return TabFieldVertical;
}(React.Component);
TabFieldVertical.defaultProps = {
  size: 's'
};
TabFieldVertical.isTabControl = true;
TabFieldVertical.isTabControlVertical = true;
TabFieldVertical.getDefaultValue = TabField.getDefaultValue;
TabFieldVertical.isEmpty = TabField.isEmpty;
export default TabFieldVertical;
// #sourceMappingURL=TabFieldVertical.js.map