import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["value", "onChange"],
  _excluded2 = ["labelLeft", "labelRight", "size", "className"];
import React, { useCallback } from 'react';
import { dfCN } from '../../helpers/cn';
import { Switch } from '@gravity-ui/uikit';
import './TumblerControl.css';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var block = dfCN('tumbler-control');
function TumblerControl(_ref) {
  var value = _ref.value,
    onChange = _ref.onChange,
    extras = _objectWithoutProperties(_ref, _excluded);
  var onTumblerChange = useCallback(function () {
    return onChange(!value);
  }, [onChange, value]);
  var labelLeft = extras.labelLeft,
    labelRight = extras.labelRight,
    _extras$size = extras.size,
    size = _extras$size === void 0 ? 'm' : _extras$size,
    className = extras.className,
    rest = _objectWithoutProperties(extras, _excluded2);
  return /*#__PURE__*/_jsxs("span", {
    className: block({
      size: size
    }),
    children: [labelLeft, /*#__PURE__*/_jsx(Switch, _objectSpread(_objectSpread({}, rest), {}, {
      size: size,
      className: block('switch', {
        'label-left': Boolean(labelLeft),
        'label-right': Boolean(labelRight)
      }, className),
      onChange: onTumblerChange,
      checked: value
    })), labelRight]
  });
}
TumblerControl.getDefaultValue = function () {
  return false;
};
TumblerControl.isEmpty = function (value) {
  return typeof value !== 'boolean' || !value;
};
export default TumblerControl;
// #sourceMappingURL=TumblerControl.js.map